   var Cylinders = new Array();     //  An empty array of cylinders
   var n_Cylinders = 0;             //  Count of installed cylinders

   // Max number of cylinders is determined by the space reserved in
   // the selection box on the form.
   var Max_Cylinders = document.JFANTC.Cline.options.length;
   
   // Initialise the form with empty cylinder slots.
   for( var n=0; n<Max_Cylinders; n++) show_cylinder( n);

   //  Redraw the entry for a cylinder in the selection box.  If
   //  the slot is empty, draw in the blank line.
   function show_cylinder( n)
   {
      if( n < n_Cylinders)
      {
         var c = Cylinders[n];
		 c.cr = document.JFANTC.c_radius.value;
         var text = 
              "#" + (n+1) + ": diam=" + c.cr + // show diameter in text, not calc'd radius
                            ", bottom_h=" + c.height1 + 
                            ", top_h=" + c.height2;
         if( c.connect == G.CONNECT_GROUND) text += ", grounded";
         if( c.connect == G.CONNECT_TOPLOAD) text += ", topload";
      }
      else
         text = "#" + (n+1)+" __________________________________";
      document.JFANTC.Cline.options[n].text = text;
	  document.JFANTC.cylinder_count.value = n_Cylinders;
   }

   //  Initialise an element of our Cylinders[] array and install it
   //  with GeoTC.  Our array holds dimensions in the users units,
   //  with conversion to metric deferred until the component is
   //  installed.
   function install_cylinder( c)   {
    var form = document.JFANTC;
	NotNum(form);

   if(form.c_radius.value > 0) {c.radius = form.c_radius.value * .5;}
   else {c.radius = form.c_radius.value;}
   
      c.height1 = form.c_height1.value;
      c.height2 = form.c_height2.value;

	  if((form.c_radius.value <= 0)||(form.c_height1.value < 0)||((form.c_height2.value-form.c_height1.value)<= 0)) { 
	  alert('Input values are missing or physically impossible:\n' + '\n-->> check your C Y L I N D E R inputs\n-->> Radius must be greater than 0\n-->> Bottom Height cannot be less than 0\n-->> Top Height cannot be below Bottom Height\nIMPORTANT ::: REMOVE this cylinder and RE-ENTER a cylinder with good inputs before running analysis.');  }
	  
      if( form.CT.checked)
         c.connect = G.CONNECT_TOPLOAD;
      if( form.CG.checked)
         c.connect = G.CONNECT_GROUND;

      // Attach GeoTC's component object to it.
			
      c.comp = G.install_cylinder( UnitsIn( c.radius),
                                 UnitsIn( c.height1),
                                 UnitsIn( c.height2), c.connect);
      drawcoil();
   }

   //  Create a new cylinder.
   function add_cylinder()
   {  
      //  Create an object c and attach all the dimensions to it,
      if( n_Cylinders == Max_Cylinders) return;
 
      var c = new Object;          // Create an object to put in our array
      c.unit = n_Cylinders;          //  Assign a unit number
      install_cylinder( c);          //  Setup the cylinder object
      Cylinders[ n_Cylinders++] = c;   //  Add to our array
      show_cylinder( c.unit);        //  Update the list of cylinders on the form
   }

   // Remove any cylinders selected in the box.
   function remove_cylinder()
   {
      for( var unit = 0; unit<n_Cylinders; unit++)
         if( document.JFANTC.Cline.options[unit].selected)
         {
            // Remove this cylinder from GeoTC.
            G.remove( Cylinders[unit].comp);

            // Remove this cylinder from our array.
            n_Cylinders--;
            for( var n=unit; n<n_Cylinders; n++) Cylinders[n] = Cylinders[n+1];

            // Redraw the list of cylinders on the form.
            for( var n=0; n<Max_Cylinders; n++) show_cylinder( n); 
         }
		 zeroC();
      drawcoil();
   }

   //  When a cylinder is selected in the box, copy its values to
   //  the editing boxes of the form.
   function select_cylinder()
   {
      for( var n=0; n<n_Cylinders; n++)
         if( document.JFANTC.Cline.options[n].selected)
         {
            var c = Cylinders[n];
            document.JFANTC.c_radius.value = c.cr;
            document.JFANTC.c_height1.value = c.height1;
            document.JFANTC.c_height2.value = c.height2;
            if( c.connect == G.CONNECT_TOPLOAD)
            {
               document.JFANTC.CT.checked = true;
               document.JFANTC.CG.checked = false;
            }
            else
            if( c.connect == G.CONNECT_GROUND)
            {
               document.JFANTC.CG.checked = true;
               document.JFANTC.CT.checked = false;
            }

            return;
         }   
   }

   //  When the user hits the Edit button, copy the values into the
   //  currently selected cylinder, remove the GeoTC component and
   //  reinstall it with the new values.  We keep the same slot in
   //  our Cylinders[] array.
   function edit_cylinder()
   {
      for( var n=0; n<n_Cylinders; n++)
         if( document.JFANTC.Cline.options[n].selected)
         {
            var c = Cylinders[n];
            G.remove( c.comp);
            install_cylinder( c);
			drawcoil();
            show_cylinder( c.unit);
            return;
         }   
   }
function zeroC() {
      document.JFANTC.c_radius.value = Number(0);
      document.JFANTC.c_height1.value = Number(0);
      document.JFANTC.c_height2.value = Number(0);
	  }
