   var Discs = new Array();     //  An empty array of discs
   var n_Discs = 0;             //  Count of installed discs

   // Max number of discs is determined by the space reserved in
   // the selection box on the form.
   var Max_Discs = document.JFANTC.Dline.options.length;
   
   // Initialise the form with empty disc slots.
   for( var n=0; n<Max_Discs; n++) show_disc( n);

   //  Redraw the entry for a disc in the selection box.  If
   //  the slot is empty, draw in the blank line.
   function show_disc( n)
   {
      if( n < n_Discs)
      {
         var d = Discs[n];
		 d.din = document.JFANTC.d_inner.value;
		 d.dout = document.JFANTC.d_outer.value;
         var text = 
              "#" + (n+1) + ": inside=" + d.din + // show diameter in text, not calc'd radius
                            ", outside=" + d.dout + // show diameter in text, not calc'd radius
                            ", height=" + d.height;
         if( d.connect == G.CONNECT_GROUND) text += ", grounded";
         if( d.connect == G.CONNECT_TOPLOAD) text += ", topload";
      }
      else
         text = "#" + (n+1)+" __________________________________";
      document.JFANTC.Dline.options[n].text = text;
	  document.JFANTC.disc_count.value = n_Discs;
   }

   //  Initialise an element of our Discs[] array and install it
   //  with GeoTC.  Our array holds dimensions in the users units,
   //  with conversion to metric deferred until the component is
   //  installed.
   function install_disc( d) {
     var form = document.JFANTC;
     NotNum(form);
	 
     if(form.d_inner.value > 0) {d.inner = form.d_inner.value * .5;}
	 else {d.inner = form.d_inner.value;}

     if(form.d_outer.value > 0) {d.outer = form.d_outer.value * .5;}
	 else {d.outer = form.d_outer.value;}
	 
     d.height = form.d_height.value;
	   
	 if((form.d_height.value < 0)||((form.d_inner.value < 0) || (form.d_outer.value - form.d_inner.value)<=0)||(form.d_outer.value <= 0)) { 
	 alert('Input values are missing or physically impossible:\n' + '\n-->> check your D I S C inputs\n-->> Inner Diameter must be smaller than Outer Diameter\n-->> Height cannot be less than 0\n-->> etc.. etc..\nIMPORTANT ::: REMOVE this disc and RE-ENTER a disc with good inputs before running analysis.');  }
  
      if( form.DT.checked)
         d.connect = G.CONNECT_TOPLOAD;
      if( form.DG.checked)
         d.connect = G.CONNECT_GROUND;

      // Attach GeoTC's component object to it. 
      d.comp = G.install_disc( UnitsIn( d.inner),
                               UnitsIn( d.outer),
                               UnitsIn( d.height), d.connect);
      drawcoil();
   }

   //  Create a new disc.
   function add_disc()
   {
      //  Create an object t and attach all the dimensions to it,
      if( n_Discs == Max_Discs) return;
 
      var d = new Object;          // Create an object to put in our array
      d.unit = n_Discs;          //  Assign a unit number
      install_disc( d);          //  Setup the disc object
      Discs[ n_Discs++] = d;   //  Add to our array
      show_disc( d.unit);        //  Update the list of discs on the form
   }

   // Remove any discs selected in the box.
   function remove_disc()
   {
      for( var unit = 0; unit<n_Discs; unit++)
         if( document.JFANTC.Dline.options[unit].selected)
         {
            // Remove this disc from GeoTC.
            G.remove( Discs[unit].comp);

            // Remove this disc from our array.
            n_Discs--;
            for( var n=unit; n<n_Discs; n++) Discs[n] = Discs[n+1];

            // Redraw the list of discs on the form.
            for( var n=0; n<Max_Discs; n++) show_disc( n); 
         }
		 zeroD();
      drawcoil();
   }

   //  When a disc is selected in the box, copy its values to
   //  the editing boxes of the form.
   function select_disc()
   {
      for( var n=0; n<n_Discs; n++)
         if( document.JFANTC.Dline.options[n].selected)
         {
            var d = Discs[n];
            document.JFANTC.d_inner.value = d.din;
            document.JFANTC.d_outer.value = d.dout;
            document.JFANTC.d_height.value = d.height;
            if( d.connect == G.CONNECT_TOPLOAD)
            {
               document.JFANTC.DT.checked = true;
               document.JFANTC.DG.checked = false;
            }
            else
            if( d.connect == G.CONNECT_GROUND)
            {
               document.JFANTC.DG.checked = true;
               document.JFANTC.DT.checked = false;
            }

            return;
         }   
   }

   //  When the user hits the Edit button, copy the values into the
   //  currently selected disc, remove the GeoTC component and
   //  reinstall it with the new values.  We keep the same slot in
   //  our Discs[] array.
   function edit_disc()
   {
      for( var n=0; n<n_Discs; n++)
         if( document.JFANTC.Dline.options[n].selected)
         {
            var d = Discs[n];
            G.remove( d.comp);
            install_disc( d);
			drawcoil();
            show_disc( d.unit);
            return;
         }   
   }
function zeroD() {
      document.JFANTC.d_inner.value = Number(0);
      document.JFANTC.d_outer.value = Number(0);
      document.JFANTC.d_height.value = Number(0);
	  }
