   var Spheres = new Array();     //  An empty array of spheres
   var n_Spheres = 0;             //  Count of installed spheres

   // Max number of spheres is determined by the space reserved in
   // the selection box on the form.
   var Max_Spheres = document.JFANTC.Sline.options.length;
   
   // Initialise the form with empty sphere slots.
   for( var n=0; n<Max_Spheres; n++) show_sphere( n);

   //  Redraw the entry for a sphere in the selection box.  If
   //  the slot is empty, draw in the blank line.
   function show_sphere( n)
   {
      if( n < n_Spheres)
      {
         var sp = Spheres[n];
		 sp.hdiam = document.JFANTC.sp_horz.value;
		 sp.vdiam = document.JFANTC.sp_vert.value;
         var text = 
              "#" + (n+1) + ": horz=" + sp.hdiam + 
                            ", vert=" + sp.vdiam + 
                            ", height=" + sp.height;
         if( sp.connect == G.CONNECT_GROUND) text += ", grounded";
         if( sp.connect == G.CONNECT_TOPLOAD) text += ", topload";
      }
      else
         text = "#" + (n+1)+" __________________________________";
      document.JFANTC.Sline.options[n].text = text;
	  document.JFANTC.sphere_count.value = n_Spheres;
   }

   //  Initialise an element of our Spheres[] array and install it
   //  with GeoTC.  Our array holds dimensions in the users units,
   //  with conversion to metric deferred until the component is
   //  installed.

   function install_sphere( sp) {
   	  var form = document.JFANTC;
	  NotNum(form);
	  
   	  if(form.sp_horz.value > 0) {sp.horz = form.sp_horz.value * .5;}
	  else {sp.horz = form.sp_horz.value;}
	  
   	  if(form.sp_vert.value > 0) {sp.vert = form.sp_vert.value * .5;}
	  else {sp.vert = form.sp_vert.value;}
	  
      sp.height = form.sp_height.value;
	  
	  if((form.sp_horz.value <= 0)||(form.sp_vert.value <= 0)||(form.sp_height.value < 0)) { 
	  alert('Input values are missing or physically impossible:\n' + '\n-->> check your S P H E R E inputs\n-->> Both Horz and Vert must have values greater than 0\n-->> Height cannot be less than 0\nIMPORTANT ::: REMOVE this sphere and RE-ENTER a sphere with good inputs before running analysis.');  }

      if( form.ST.checked)
         sp.connect = G.CONNECT_TOPLOAD;
      if( form.SG.checked)
         sp.connect = G.CONNECT_GROUND;

      // Attach GeoTC's component object to it. 
      sp.comp = G.install_sphere( UnitsIn( sp.horz),
                                 UnitsIn( sp.vert),
                                 UnitsIn( sp.height), sp.connect);
      drawcoil();
   }

   //  Create a new sphere.
   function add_sphere()
   {
      //  Create an object sp and attach all the dimensions to it,
      if( n_Spheres == Max_Spheres) return;
 
      var sp = new Object;          // Create an object to put in our array
      sp.unit = n_Spheres;          //  Assign a unit number
      install_sphere( sp);          //  Setup the sphere object
      Spheres[ n_Spheres++] = sp;   //  Add to our array
      show_sphere( sp.unit);        //  Update the list of spheres on the form
   }

   // Remove any spheres selected in the box.
   function remove_sphere()
   {
      for( var unit = 0; unit<n_Spheres; unit++)
         if( document.JFANTC.Sline.options[unit].selected)
         {
            // Remove this sphere from GeoTC.
            G.remove( Spheres[unit].comp);

            // Remove this sphere from our array.
            n_Spheres--;
            for( var n=unit; n<n_Spheres; n++) Spheres[n] = Spheres[n+1];

            // Redraw the list of spheres on the form.
            for( var n=0; n<Max_Spheres; n++) show_sphere( n); 
         }
		 zeroS();
      drawcoil();
   }

   //  When a sphere is selected in the box, copy its values to
   //  the editing boxes of the form.
   function select_sphere()
   {
      for( var n=0; n<n_Spheres; n++)
         if( document.JFANTC.Sline.options[n].selected)
         {
            var sp = Spheres[n];
            document.JFANTC.sp_horz.value = sp.hdiam;
            document.JFANTC.sp_vert.value = sp.vdiam;
            document.JFANTC.sp_height.value = sp.height;
            if( sp.connect == G.CONNECT_TOPLOAD)
            {
               document.JFANTC.ST.checked = true;
               document.JFANTC.SG.checked = false;
            }
            else
            if( sp.connect == G.CONNECT_GROUND)
            {
               document.JFANTC.SG.checked = true;
               document.JFANTC.ST.checked = false;
            }

            return;
         }   
   }

   //  When the user hits the Edit button, copy the values into the
   //  currently selected sphere, remove the GeoTC component and
   //  reinstall it with the new values.  We keep the same slot in
   //  our Spheres[] array.
   function edit_sphere()
   {
      for( var n=0; n<n_Spheres; n++)
         if( document.JFANTC.Sline.options[n].selected)
         {
            var sp = Spheres[n];
            G.remove( sp.comp);
            install_sphere( sp);
			drawcoil(); 
            show_sphere( sp.unit);
            return;
         }   
   }
function zeroS() {
      document.JFANTC.sp_horz.value = Number(0);
      document.JFANTC.sp_vert.value = Number(0);
      document.JFANTC.sp_height.value = Number(0);
	  }
