   var Toroids = new Array();     //  An empty array of toroids
   var n_Toroids = 0;             //  Count of installed toroids

   // Max number of toroids is determined by the space reserved in
   // the selection box on the form.
   var Max_Toroids = document.JFANTC.Tline.options.length;
  
   // Initialise the form with empty toroid slots.
   for( var n=0; n<Max_Toroids; n++) show_toroid( n);

   //  Redraw the entry for a toroid in the selection box.  If
   //  the slot is empty, draw in the blank line.
   function show_toroid( n)
   {
      if( n < n_Toroids)
      {
         var t = Toroids[n];
		 t.tin = document.JFANTC.t_inner.value;
		 t.tout = document.JFANTC.t_outer.value;
		 var text = 
              "#" + (n+1) + ": minor=" + t.tin + // show diameter in text, not calc'd radius
                            ", major=" + t.tout + // show diameter in text, not calc'd radius
                            ", height=" + t.height;
         if( t.connect == G.CONNECT_GROUND) text += ", grounded";
         if( t.connect == G.CONNECT_TOPLOAD) text += ", topload";
      }
      else
         text = "#" + (n+1)+" __________________________________";
      document.JFANTC.Tline.options[n].text = text;
	  document.JFANTC.toroid_count.value = n_Toroids;
   }
		
   //  Initialise an element of our Toroids[] array and install it
   //  with GeoTC.  Our array holds dimensions in the users units,
   //  with conversion to metric deferred until the component is
   //  installed.
   function install_toroid( t) {
      var form = document.JFANTC;
	  NotNum(form);
	  	  
	  if(form.t_inner.value > 0) {t.inner = (form.t_outer.value-(form.t_inner.value*2)) * 0.5;}
      else {t.inner = form.t_inner.value;}
	  if(form.t_outer.value > 0) {t.outer = form.t_outer.value * 0.5;}
      else {t.outer = form.t_outer.value;}
      t.height = form.t_height.value;

	  if((form.t_height.value < 0)||(form.t_inner.value == 0)||(form.t_outer.value <= 0)||((form.t_inner.value * 2) >= form.t_outer.value)) { 
	  alert('Input values are missing or physically impossible:\n' + '\n-->> check your T O R O I D inputs\n-->> Major Diameter must be larger than 2 x Minor Diameter\n-->> Height cannot be less than 0\nIMPORTANT ::: REMOVE this toroid and RE-ENTER a toroid with good inputs before running analysis.');  }
	  
      if( form.TT.checked)
         t.connect = G.CONNECT_TOPLOAD;
      if( form.TG.checked)
         t.connect = G.CONNECT_GROUND;

      // Attach GeoTC's component object to it.
      t.comp = G.install_toroid( UnitsIn( t.inner),
	  							 UnitsIn( t.outer),
								 UnitsIn( t.height), t.connect);
	  drawcoil();
   }
   
   //  Create a new toroid.
   function add_toroid()
   {
      //  Create an object t and attach all the dimensions to it,
      if( n_Toroids == Max_Toroids) return;
 
      var t = new Object;          // Create an object to put in our array
      t.unit = n_Toroids;          //  Assign a unit number
      install_toroid( t);          //  Setup the toroid object
      Toroids[ n_Toroids++] = t;   //  Add to our array
      show_toroid( t.unit);        //  Update the list of toroids on the form
   }

   // Remove any toroids selected in the box.
   function remove_toroid()
   {
      for( var unit = 0; unit<n_Toroids; unit++)
         if( document.JFANTC.Tline.options[unit].selected)
         {
            //Remove this toroid from GeoTC.
            G.remove( Toroids[unit].comp);

            // Remove this toroid from our array.
            n_Toroids--;
            for( var n=unit; n<n_Toroids; n++) Toroids[n] = Toroids[n+1];
			
            // Redraw the list of toroids on the form.
            for( var n=0; n<Max_Toroids; n++) show_toroid( n); 
         }
		 zeroT();
      drawcoil();
   }

   //  When a toroid is selected in the box, copy its values to
   //  the editing boxes of the form.
   function select_toroid()
   {
      for( var n=0; n<n_Toroids; n++)
         if( document.JFANTC.Tline.options[n].selected)
         {
            var t = Toroids[n];
            document.JFANTC.t_inner.value = t.tin;
            document.JFANTC.t_outer.value = t.tout;
            document.JFANTC.t_height.value = t.height;
            if( t.connect == G.CONNECT_TOPLOAD)
            {
               document.JFANTC.TT.checked = true;
               document.JFANTC.TG.checked = false;
            }
            else
            if( t.connect == G.CONNECT_GROUND)
            {
               document.JFANTC.TG.checked = true;
               document.JFANTC.TT.checked = false;
            }

            return;
         }   
   }

   //  When the user hits the Edit button, copy the values into the
   //  currently selected toroid, remove the GeoTC component and
   //  reinstall it with the new values.  We keep the same slot in
   //  our Toroids[] array.
   function edit_toroid()
   {
      for( var n=0; n<n_Toroids; n++)
         if( document.JFANTC.Tline.options[n].selected)
         {
            var t = Toroids[n];
            G.remove( t.comp);
            install_toroid( t);
			drawcoil();
            show_toroid( t.unit);
            return;
         }   
   }
function zeroT() {
      document.JFANTC.t_inner.value = Number(0);
      document.JFANTC.t_outer.value = Number(0);
      document.JFANTC.t_height.value = Number(0);
	  }
