function FTC(form) {
var G = new GeoTC( open_errwin);
ClearExamples(form);
NotNum(form);
wd_awg(form);

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//  Now define the system.  Call the G.install_ functions as necessary.  
//  You can have as many toroids, spheres, discs, walls, etc as necessary.
//  G.reset() removes all objects.

///////////////////////////////////////////////////////////////////////////
// Check if a test is checked by user
///////////////////////////////////////////////////////////////////////////
var TEST = 0;
if ( form.run1.checked)	{ TEST = 1;} // A toroided system
if ( form.run2.checked)	{ TEST = 2;} // A bare coil
if ( form.run3.checked)	{ TEST = 3;} // Sphere-loaded coil in open air
if ( form.run4.checked)	{ TEST = 4;} // Isolated toroid floating in space
if ( form.run5.checked)	{ TEST = 5;} // Isolated sphere
if ( form.run6.checked)	{ TEST = 6;} // Isolated disc
if ( form.run7.checked)	{ TEST = 7;} // Self L of helical
if ( form.run8.checked)	{ TEST = 8;} // Self L of flat spiral
if ( form.run9.checked)	{ TEST = 9;} // Self L of cone
if ( form.run10.checked){ TEST = 10;} // Self L of inverted cone
if ( form.run11.checked){ TEST = 11;} // Self L of single turn loop
if ( form.run12.checked){ TEST = 12;} // Mutual between two helicals
if ( form.run13.checked){ TEST = 13;} // Mutual between two flat spirals
if ( form.run14.checked){ TEST = 14;} // Mutual between two flat loops
if ( form.run15.checked){ TEST = 15;} // Toroided Secondary Resonant Fres, C, L
if ( form.run16.checked){ TEST = 16;} // Cap between concentric spheres
if ( form.run17.checked){ TEST = 17;} // Cap to infinity of two spheres just touching
if ( form.run18.checked){ TEST = 18;} // Cap of toroid in-situ
if ( form.run19.checked){ TEST = 19;} // Cap of coil to coil
if ( form.run20.checked){ TEST = 20;} // Bare Secondary Resonance analysis
if ( form.run21.checked){ TEST = 21;} // Loaded Secondary w/2 toroid Resonance analysis (bba)
///////////////////////////////////////////////////////////////////////////
//  LOGIC OF USER SELECTIONS
///////////////////////////////////////////////////////////////////////////
validate(form);
if(good == true) {
form.runmsg.value="F A N T C should now be running in a second browser window";
if( TEST == 0)  {
	doc = open("","out"); // open output window
	doc.document.writeln( "<pre>Running F A N T C using core functions of G E O T C version: " + G.version + "\n<br>");
	doc.document.writeln(testmsg + "<br>");
	doc.document.writeln("Computing ..... please wait" + "<br>");
 
if(analysis == 1) {
	G.reset();
	G.detail( det); // user input of detail level
	
	if( form.com2.checked) { // secondary profiles
		if( form.SL.checked) { var secondary = G.install_secondary( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), G.PROFILE_LOADED);}
		if( form.SB.checked) { var secondary = G.install_secondary( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), G.PROFILE_BARE);}
		if( form.SLIN.checked) { var secondary = G.install_secondary( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), G.PROFILE_LINEAR);}
		if( form.SDC.checked)  { var secondary = G.install_secondary( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), G.PROFILE_DC);}
		}
	if( form.com3.checked) { // primary
		var primary = G.install_primary( UnitsIn( p_radius1), UnitsIn( p_height1), UnitsIn( p_radius2), UnitsIn( p_height2));
		}
	if( form.com4.checked)	{ // toroid connections
		for( var n=0; n<n_Toroids; n++) {
			var t = Toroids[n];
			t = G.install_toroid( UnitsIn( t.inner), UnitsIn( t.outer), UnitsIn( t.height), t.connect);
			}
		}
	if( form.com5.checked) { // sphere connections
		for( var n=0; n<n_Spheres; n++) {
        	var sp = Spheres[n];
			sp = G.install_sphere( UnitsIn( sp.horz), UnitsIn( sp.vert), UnitsIn( sp.height), sp.connect);
			}						 
		}
	if( form.com6.checked) { // disc connections
		for( var n=0; n<n_Discs; n++) {
			var d = Discs[n];
			d = G.install_disc( UnitsIn( d.inner), UnitsIn( d.outer), UnitsIn( d.height), d.connect);
			}						 
		}
	if( form.com7.checked) { // cylinder connections
		for( var n=0; n<n_Cylinders; n++) {
			var c = Cylinders[n];
			c = G.install_cylinder( UnitsIn( c.radius), UnitsIn( c.height1), UnitsIn( c.height2), c.connect);
			}
		}
	if( form.com1.checked) { // ground plane
		var gnd = G.install_groundplane( UnitsIn(g_radius));	
		}
	if( form.com12.checked) { // roof and wall
		var roof = G.install_roof( UnitsIn(r_radius), UnitsIn(r_height));
		var wall = G.install_wall( UnitsIn(w_radius), UnitsIn(w_height));
		}
//////////////////////// END OF OBJECT DEFINITIONS //////////////////////////////////

/////////////////////////// BEGIN RUN DEFINITIONS //////////////////////////////////
	if( form.com13.checked) { // C of objects in-situ
		if( form.com4.checked) { // if toroid
			if( form.com1.checked) { var Ces = G.compute_Ces( t, gnd) * 1e12; }
			if( form.com12.checked) {	Ces += G.compute_Ces( t, wall) * 1e12;
										Ces += G.compute_Ces( t, roof) * 1e12; }
			if( form.com3.checked) { Ces += G.compute_Ces( t, primary) * 1e12;	}
			Ces = G.compute_Ces( t) * 1e12;
			compare_C_O_Tresult( format( Ces, 100));		
			end_test( G);
			}
		if( form.com5.checked) { // if sphere
			if( form.com1.checked) { var Ces = G.compute_Ces( sp, gnd) * 1e12; }
			if( form.com12.checked) {	Ces += G.compute_Ces( sp, wall) * 1e12;
										Ces += G.compute_Ces( sp, roof) * 1e12; }
			if( form.com3.checked) { Ces += G.compute_Ces( sp, primary) * 1e12;	}
				Ces = G.compute_Ces( sp) * 1e12;
				compare_C_O_Sresult( format( Ces, 100));		
				end_test( G);
			}
		if( form.com6.checked) { // if disc
			if( form.com1.checked) { var Ces = G.compute_Ces( d, gnd) * 1e12; }
			if( form.com12.checked) {	Ces += G.compute_Ces( d, wall) * 1e12;
										Ces += G.compute_Ces( d, roof) * 1e12; }
			if( form.com3.checked) { Ces += G.compute_Ces( d, primary) * 1e12;	}
				Ces = G.compute_Ces( d) * 1e12;
				compare_C_O_Dresult( format( Ces, 100));		
				end_test( G);
			}
		if( form.com7.checked) { // if cylinder
			if( form.com1.checked) { var Ces = G.compute_Ces( c, gnd) * 1e12; }
			if( form.com12.checked) {	Ces += G.compute_Ces( c, wall) * 1e12;
										Ces += G.compute_Ces( c, roof) * 1e12; }
			if( form.com3.checked) { Ces += G.compute_Ces( c, primary) * 1e12;	}
				Ces = G.compute_Ces( c) * 1e12;
				compare_C_O_Cresult( format( Ces, 100));		
				end_test( G);
			}	
		} // com13

	if( form.com14.checked) { // coil-coil capacitance
		Ces = G.compute_Ces( secondary, primary) * 1e12;
		compare_C_Cresult( format( Ces, 100));
		end_test( G);
		} // end com14

	if( form.com15.checked) { // ces of components
		if((form.com1.checked)||(form.com12.checked)||(form.com2.checked)||(form.com3.checked)||(form.com4.checked)||(form.com5.checked)||(form.com6.checked)||(form.com7.checked)) {
			var Ces = G.compute_Ces() * 1e12;
			compare_Cresult( format( Ces, 100));
			end_test( G);
		}
	} // end Capacitance
  } // end analysis C
//////////////////////// END OF CAPACITANCE ANALYSIS ///////////////////////////////

//////////////////////// BEGIN INDUCTANCE ANALYSIS /////////////////////////////////
if(analysis == 2) {
	if( form.com10.checked) { // primary inductance
		G.reset();
		G.detail( det);
		var coil = G.install_coil( UnitsIn( p_radius1), UnitsIn( p_height1), UnitsIn( p_radius2), UnitsIn( p_height2), p_turn, UnitsIn( p_wirad));
		var Ldc = G.compute_Ldc( coil) * 1e6;
		compare_L1result( format( Ldc, 100000));
		end_test( G);
		} // end L1 check

	if( form.com9.checked) { // secondary inductance
		G.reset();
		G.detail( det);
		var coil = G.install_coil( UnitsIn(s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), s_turn, UnitsIn( s_wirad));
		var Ldc = G.compute_Ldc( coil) * 1e3;
		compare_L2result( format( Ldc, 100000));
		end_test( G);
		} // end L2 check

	if( form.com11.checked) { // mutual inductance
		G.reset();
		G.detail( det);
		var pri = G.install_coil( UnitsIn( p_radius1), UnitsIn( p_height1), UnitsIn( p_radius2), UnitsIn( p_height2), p_turn, UnitsIn( p_wirad));
		var sec = G.install_coil( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), s_turn, UnitsIn( s_wirad));
		var L1 = G.compute_Ldc( pri) * 1e6;
		var L2 = G.compute_Ldc( sec) * 1e6;
		var M = G.compute_Mdc( pri, sec) * 1e6;
		compare_LMresult( format( M, 100000));
		compare_Kresult( format( M/Math.sqrt(L1*L2), 1000000));
		end_test( G);
		} // end Lm check
	} //end analysis L
//////////////////////////////////// END INDUCTANCE ANALYSIS ////////////////////////

/////////////////////////////////// BEGIN FRES WITH C & L BREAKDOWN //////////////////
if(analysis == 3) {
		G.reset();
		G.detail( det);
			
	if( form.com2.checked) { // secondary profiles	
		G.install_secondary( UnitsIn( s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), G.PROFILE_LOADED);
		}
	if( form.com3.checked) { // primary
		var primary = G.install_primary( UnitsIn( p_radius1), UnitsIn( p_height1), UnitsIn( p_radius2), UnitsIn( p_height2));
		}	
	if( form.com1.checked) { // ground plane
		var gnd = G.install_groundplane( UnitsIn(g_radius));	
		}
	if( form.com12.checked) { // roof and wall
		var roof = G.install_roof( UnitsIn(r_radius), UnitsIn(r_height));
		var wall = G.install_wall( UnitsIn(w_radius), UnitsIn(w_height));
		}
	if( form.com4.checked)	{ // toroid connections
			for( var n=0; n<n_Toroids; n++) {
				var t = Toroids[n];
				t = G.install_toroid( UnitsIn( t.inner), UnitsIn( t.outer), UnitsIn( t.height), t.connect);
			}
		}
	if( form.com5.checked) { // sphere connections
			for( var n=0; n<n_Spheres; n++) {
        		var sp = Spheres[n];
				sp = G.install_sphere( UnitsIn( sp.horz), UnitsIn( sp.vert), UnitsIn( sp.height), sp.connect);
			}
		}
	if( form.com6.checked) { // disc connections
			for( var n=0; n<n_Discs; n++) {
				var d = Discs[n];
				d = G.install_disc( UnitsIn( d.inner), UnitsIn( d.outer), UnitsIn( d.height), d.connect);
			}
		}
	if( form.com7.checked) { // cylinder connections
			for( var n=0; n<n_Cylinders; n++) {
				var c = Cylinders[n];
				c = G.install_cylinder( UnitsIn( c.radius), UnitsIn( c.height1), UnitsIn( c.height2), c.connect);
			}
	 	}
		var coil = G.install_coil( UnitsIn(s_radius1), UnitsIn( s_height1), UnitsIn( s_radius2), UnitsIn( s_height2), s_turn, UnitsIn( s_wirad));
		
		var result = G.compute_F( coil);	
		compare_Fresult( format( result.F/1000, 100));
		doc.document.writeln("V/I prifile data with corresponding secondary length fragments....<br>");
		doc.document.writeln( "S, V, I<br>");
		doc.document.writeln( "0.00, 0.00, 1.00<br>");

		var St = 0;
		for( var n=0; n<result.N; n++) {
    	St += result.S[n];
    	doc.document.writeln( format( St, 100)+", "+
                            format( result.V[n], 100)+", "+
                            format( result.I[n], 100));
							}
		doc.document.writeln("<p>");
		compare_Les_result( format( result.Les*1e3, 100000));
		compare_Ces_result( format( result.Ces*1e12, 100000));
		compare_Ldc_result( format( result.Ldc*1e3, 100000));
		compare_Cdc_result( format( result.Cdc*1e12, 100000));		
		compare_Lee_result( format( result.Lee*1e3, 100000));
		compare_Cee_result( format( result.Cee*1e12, 100000));
		compare_Ctop_result( format( result.Ctop*1e12, 100000));
		G.graph_I( result);
		G.graph_V( result);
		end_test( G);
 } // end analysis R
} // End of TEST = 0
///////////////////////////////////////////////////////////////////////////
//  Tests 1 though 14: Invoke test inputs into form
///////////////////////////////////////////////////////////////////////////
if( TEST == 1){	Tog1(form);}
if( TEST == 2){	Tog2(form);}
if( TEST == 3){	Tog3(form);}
if( TEST == 4){	Tog4(form);}
if( TEST == 5){	Tog5(form);}
if( TEST == 6){	Tog6(form);}
if( TEST == 7){	Tog7(form);}
if( TEST == 8){	Tog8(form);}
if( TEST == 9){	Tog9(form);}
if( TEST == 10){ Tog10(form);}
if( TEST == 11){ Tog11(form);}
if( TEST == 12){ Tog12(form);}
if( TEST == 13){ Tog13(form);}
if( TEST == 14){ Tog14(form);}
if( TEST == 15){ Tog15(form);}
if( TEST == 16){ Tog16(form);}
if( TEST == 17){ Tog17(form);}
if( TEST == 18){ Tog18(form);}
if( TEST == 19){ Tog19(form);}
if( TEST == 20){ Tog20(form);}
if( TEST == 21){ Tog21(form);}
	testmsg=('');
	doc.document.close();
form.runmsg.value="F A N T C analysis is now complete. Check browser window";
 } // end validation
} // END
///////////////////////////////////////////////////////////////////////////
// A utility to format numbers.
///////////////////////////////////////////////////////////////////////////
function format( val, precision)
{
   return Math.round( precision * val)/precision;
}
///////////////////////////////////////////////////////////////////////////
// A utility to output capture and output errors
///////////////////////////////////////////////////////////////////////////
function open_errwin()
 {
    return open("","error","width=500 height=300");
 }
///////////////////////////////////////////////////////////////////////////
// Utilities to report test comparisons.
///////////////////////////////////////////////////////////////////////////

function compare_Cresult( result) {  // Ces - system capacitance
	doc.document.writeln("System or Object Capacitance: " + result + " pF<p>");
	}
function compare_C_Cresult( result) {  // Ces - coil to coil - pri-sec
	doc.document.writeln("Capacitance (coil to coil): " + result + " pF<p>");
	}
function compare_C_O_Tresult( result) {  // Ces - Object In-Situ
	doc.document.writeln("Toroid(s) Capacitance (in situation with system): " + result + " pF<p>");
	}
function compare_C_O_Sresult( result) {  // Ces - Object In-Situ
	doc.document.writeln("Sphere(s) Capacitance - (in situation with system): " + result + " pF<p>");
	}
function compare_C_O_Dresult( result) {  // Ces - Object In-Situ
	doc.document.writeln("Disc(s) Capacitance - (in situation with system): " + result + " pF<p>");
	}
function compare_C_O_Cresult( result) {  // Ces - Object In-Situ
	doc.document.writeln("Cylinder(s) Capacitance - (in situation with system): " + result + " pF<p>");
	}
function compare_L1result( result) {  // Lp
	doc.document.writeln("Primary Inductance (L1): " + result + " uH<p>");
	}
function compare_L2result( result) {  // Ls
	doc.document.writeln("Secondary Inductance (L2): " + result + " mH<p>")
	}
function compare_LMresult( result) { // Lm
	doc.document.writeln("Mutual Inductance (L1,L2): " + result + " uH<p>");
	}
function compare_Kresult( result) { // K
    doc.document.writeln("Coupling Coefficient(K): " + result +"<p>");
	}
function compare_Fresult( result) { // Frequency Out
	doc.document.writeln("Secondary Resonant Frequency: " + result + " kHz<p>");
	}
function compare_Lee_result( result) {  // Lee
    doc.document.writeln("Energy Storage Inductance (Lee): "+ result +" mH<p>");
	}
function compare_Les_result( result) {  // Les
    doc.document.writeln("Effective Series Inductance (Les): "+ result +" mH<p>");
	}
function compare_Ldc_result( result) {  // Ldc
    doc.document.writeln("Low Frequency Inductance (Ldc): "+ result +" mH<p>");
	}
function compare_Cee_result( result) {  // Cee
    doc.document.writeln("Energy Storage Capacitance (Cee): "+ result +" pF<p>");
	}
function compare_Ces_result( result) {  // Ces
    doc.document.writeln("Effective Shunt Capacitance (Ces): "+ result +" pF<p>");
	}
function compare_Cdc_result( result) {  // Cdc
    doc.document.writeln("Low Frequency Capacitance (Cdc): "+ result +" pF<p>");
	}
function compare_Ctop_result( result) {  // Cdc
    doc.document.writeln("Total Topload Capacitance (Ctop): "+ result +" pF<p>");
	doc.document.writeln("Definitions of Inductance and Capacitance as termed above:<p><hr>");
	doc.document.writeln("Low Frequency Inductance (Ldc) and Low Frequency Capacitance (Cdc):<br>At low frequency's the current is considered uniform along the coils length and the external capacitances<br>are distributed evenly. These values are useful as a cross-check using typical LC measurement tools.<p>");
	doc.document.writeln("Equivalent Series Inductance (Les) and Equivelent Series Capacitance (Ces):<br>At high frequency's the current is non-uniform along the coils length. These values represent the equivelent<br>series inductance and capacitance at the resonant frequency due to circulating currents affecting the coils<br>LC distribution.<p>");
	doc.document.writeln("Energy Storage Inductance (Lee):<br>The energy stored in the magnetic field from the mutual inductance between elements is considered and lumped<br>into an equivalent inductance. Lee is meaningful when describing the input impedance to the resonator.<p>");
	doc.document.writeln("Energy Storage Capacitance (Cee):<br>An equivalent lumped capacitance to represent the capacitance required to store all the energy in the<br>resonator at the instant in the cycle when all the energy is stored in the capacitance. Cee is useful to<br>obtain the top voltage from the energy stored in the capacitance. For example, Vtop = Vpri x sqrt(Cpri/Cee).")
	}
function end_test( G) {
	var elapsed = format( G.elapsed()/1000, 10);
	doc.document.writeln("Run Complete<br>Time elapsed: " + elapsed + " secs<p><hr>");
	}
