////////////////////////////////////////////////////////////////////////
// Global Variables
var G = new GeoTC();
var det = Number(1);
var testmsg = ('');
var good;
var analysis = 1;
var Reso = false;
///////////////////////////////////////////////////////////////////////////
// A utility to format numbers.
function format( val, precision)
{
   return Math.round( precision * val)/precision;
}
////////////////////////////////////////////////////////////////////////
// Popup for Notes
function helpwin(url,mwidth,mheight){ // Notes window
eval('window.open(url,"","width='+mwidth+'px,height='+mheight+'px,resizable=1,scrollbars=1")');}

////////////////////////////////////////////////////////////////////////
// break frames on entry
if (window != top) top.location.href = location.href;

////////////////////////////////////////////////////////////////////////
// Clear inputs or outputs on focus
function ClearField(field)	{
	if(field.value == field.defaultValue)	
		{ field.value = ''; }
	else 	{ field.value = ''; }
}

////////////////////////////////////////////////////////////////////////
// Convert to meters for component input
function UnitsIn( x){
 	if(document.JFANTC.inches.checked) {return x * .0254;}
	else {return x * 1;}
	}
function UnitsOut( x) {
   	if(document.JFANTC.meters.checked) {return x * 1;}
	else {return x / .0254;}
   }

////////////////////////////////////////////////////////////////////////
// Toggle Meters or Inches checkbox
function TogUnits1(form) {
if (form.inches.checked) { form.meters.checked = false;}
else if ((form.inches.checked) == false) {form.meters.checked = true;}
	}
function TogUnits2(form) {
if (form.meters.checked) { form.inches.checked = false;}
else if ((form.meters.checked) == false) {form.inches.checked = true;}
	}
	
////////////////////////////////////////////////////////////////////////
// Toggle Secondary wire d or awg size
function TogS_awg1(form) {
if (form.s_awg.checked) { form.s_wd.checked = false;}
else if ((form.s_awg.checked) == false) {form.s_wd.checked = true;}
	}
function TogS_awg2(form) {
if (form.s_wd.checked) { form.s_awg.checked = false;}
else if ((form.s_wd.checked) == false) {form.s_awg.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Primary wire d or awg size
function TogP_awg1(form) {
if (form.p_awg.checked) { form.p_wd.checked = false;}
else if ((form.p_awg.checked) == false) {form.p_wd.checked = true;}
	}
function TogP_awg2(form) {
if (form.p_wd.checked) { form.p_awg.checked = false;}
else if ((form.p_wd.checked) == false) {form.p_awg.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Toroid Connection 
function TogTT(form) {
if (form.TT.checked) { form.TG.checked = false;}
else if ((form.TG.checked) == false) {form.TT.checked = true;}
	}
function TogTG(form) {
if (form.TG.checked) { form.TT.checked = false;}
else if ((form.TT.checked) == false) {form.TG.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Sphere Connection 
function TogST(form) {
if (form.ST.checked) { form.SG.checked = false;}
else if ((form.SG.checked) == false) {form.ST.checked = true;}
	}
function TogSG(form) {
if (form.SG.checked) { form.ST.checked = false;}
else if ((form.ST.checked) == false) {form.SG.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Disc Connection 
function TogDT(form) {
if (form.DT.checked) { form.DG.checked = false;}
else if ((form.DG.checked) == false) {form.DT.checked = true;}
	}
function TogDG(form) {
if (form.DG.checked) { form.DT.checked = false;}
else if ((form.DT.checked) == false) {form.DG.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Cylinder Connection 
function TogCT(form) {
if (form.CT.checked) { form.CG.checked = false;}
else if ((form.CG.checked) == false) {form.CT.checked = true;}
	}
function TogCG(form) {
if (form.CG.checked) { form.CT.checked = false;}
else if ((form.CT.checked) == false) {form.CG.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Toggle Secondary Profile
function TogSL(form) {
if (form.SL.checked) { form.SB.checked = false;form.SLIN.checked = false;form.SDC.checked = false;}
else if ((form.SB.checked) == false||(form.SLIN.checked) == false||(form.SDC.checked) == false) {form.SL.checked = true;}
	}
function TogSB(form) {
if (form.SB.checked) { form.SL.checked = false;form.SLIN.checked = false;form.SDC.checked = false;}
else if ((form.SL.checked) == false||(form.SLIN.checked) == false||(form.SDC.checked) == false) {form.SB.checked = true;}
	}
function TogSLIN(form) {
if (form.SLIN.checked) { form.SB.checked = false;form.SL.checked = false;form.SDC.checked = false;}
else if ((form.SB.checked) == false||(form.SL.checked) == false||(form.SDC.checked) == false) {form.SLIN.checked = true;}
	}
function TogSDC(form) {
if (form.SDC.checked) { form.SB.checked = false;form.SL.checked = false;form.SLIN.checked = false;}
else if ((form.SB.checked) == false||(form.SL.checked) == false||(form.SLIN.checked) == false) {form.SDC.checked = true;}
	}

////////////////////////////////////////////////////////////////////////
// Check inputs for numbers & make 0 if not	
function NotNum(form) {

	if (form.g_radius.value == isNaN(0)){form.g_radius.value = Number(0); eval(form.g_radius);}
	if (form.w_radius.value == isNaN(0)){form.w_radius.value = Number(0); eval(form.w_radius);}
	if (form.w_height.value == isNaN(0)){form.w_height.value = Number(0); eval(form.w_height);}
	if (form.r_radius.value == isNaN(0)){form.r_radius.value = Number(0); eval(form.r_radius);}
	if (form.r_height.value == isNaN(0)){form.r_height.value = Number(0); eval(form.r_height);}
	
	if (form.s_radius1.value == isNaN(0)){form.s_radius1.value = Number(0); eval(form.s_radius1);}
	if (form.s_height1.value == isNaN(0)){form.s_height1.value = Number(0); eval(form.s_height1);}
	if (form.s_radius2.value == isNaN(0)){form.s_radius2.value = Number(0); eval(form.s_radius2);}
	if (form.s_height2.value == isNaN(0)){form.s_height2.value = Number(0); eval(form.s_height2);}
	if (form.s_turn.value == isNaN(0)){form.s_turn.value = Number(0); eval(form.s_turn);}
	if (form.s_wirad.value == isNaN(0)){form.s_wirad.value = Number(0); eval(form.s_wirad);}
	
	if (form.p_radius1.value == isNaN(0)){form.p_radius1.value = Number(0); eval(form.p_radius1);}	
	if (form.p_height1.value == isNaN(0)){form.p_height1.value = Number(0); eval(form.p_height1);}
	if (form.p_radius2.value == isNaN(0)){form.p_radius2.value = Number(0); eval(form.p_radius2);}
	if (form.p_height2.value == isNaN(0)){form.p_height2.value = Number(0); eval(form.p_height2);}
	if (form.p_turn.value == isNaN(0)){form.p_turn.value = Number(0); eval(form.p_turn);}
	if (form.p_wirad.value == isNaN(0)){form.p_wirad.value = Number(0); eval(form.p_wirad);}
	
	if (form.t_outer.value == isNaN(0)){form.t_outer.value = Number(0); eval(form.t_outer);}
	if (form.t_inner.value == isNaN(0)){form.t_inner.value = Number(0); eval(form.t_inner);}
	if (form.t_height.value == isNaN(0)){form.t_height.value = Number(0); eval(form.t_height);}
	if (form.sp_horz.value == isNaN(0)){form.sp_horz.value = Number(0); eval(form.sp_horz);}
	if (form.sp_vert.value == isNaN(0)){form.sp_vert.value = Number(0); eval(form.sp_vert);}
	if (form.sp_height.value == isNaN(0)){form.sp_height.value = Number(0); eval(form.sp_height);}
	if (form.d_inner.value == isNaN(0)){form.d_inner.value = Number(0); eval(form.d_inner);}
	if (form.d_outer.value == isNaN(0)){form.d_outer.value = Number(0); eval(form.d_outer);}
	if (form.d_height.value == isNaN(0)){form.d_height.value = Number(0); eval(form.d_height);}
	if (form.c_radius.value == isNaN(0)){form.c_radius.value = Number(0); eval(form.c_radius);}
	if (form.c_height1.value == isNaN(0)){form.c_height1.value = Number(0); eval(form.c_height1);}
	if (form.c_height2.value == isNaN(0)){form.c_height2.value = Number(0); eval(form.c_height2);}
	}	

////////////////////////////////////////////////////////////////////////
// Logic for catching input errors
function validate(form) {
good = true;
		if((Reso == false)&&(form.com9.checked == false)&&(form.com10.checked == false)&&(form.com11.checked == false)&&(form.com13.checked == false)&&(form.com14.checked == false)&&(form.com15.checked == false)) {
		alert("There is no analysis selected. \n You must first select an analysis to run.");
		good = false; return;
		}
 
	if( form.com15.checked) { // system ces
		if((form.com3.checked)&&(form.com2.checked == false)&&(form.com4.checked == false)&&(form.com5.checked == false)&&(form.com6.checked == false)&&(form.com7.checked == false)) {
			alert("Ces does not run C of primary as a function of it's own capacitance. You must select one or more of the following:\n------ Secondary \n------ Toroid \n------ Sphere \n------ Disc \n------ Cylinder \n" +
			"Don't be confused. The primary should be checked if you wish to include it's capacitive affect on the other system objects.\n If you wish to model the primary's capacitance by itself, input the primary dimensions into the secondary input boxes and run Ces.");
			good = false; return;
			}
		if((form.com2.checked == false)&&(form.com4.checked == false)&&(form.com5.checked == false)&&(form.com6.checked == false)&&(form.com7.checked == false)) {
			alert("There are no components selected for analysis. One or more of the following must be selected \n\n------ Secondary \n------ Toroid \n------ Sphere \n------ Disc \n------ Cylinder");
			good = false; return;
			}
		if( form.com2.checked) { Val_2(form);}
		if( form.com3.checked) { Val_3(form);}
		if( form.com1.checked) { Val_1(form);}
		if( form.com12.checked) { Val_12(form);}
		
	} // end com15
	
	if( form.com14.checked) { // ces coil to coil
		if((form.com2.checked == false)||(form.com3.checked == false)) {
		alert("There are no system components selected for analysis (select: primary and secondary).");
		good = false; return;
		}
		Val_2(form);
		Val_3(form);	
	} // end com14
	
	if( form.com13.checked) { // topload objects in situation with system
		if((form.com1.checked == false)&&(form.com2.checked == false)&&(form.com3.checked == false)) {
			alert("There are no system components selected for analysis.");
			good = false; return;
			}
		else if ((form.com4.checked == false)&&(form.com5.checked == false)&&(form.com6.checked == false)&&(form.com7.checked == false)) {
			alert("There are no topload objects selected for analysis.");
			good = false; return;
			}
		if( form.com2.checked) { Val_2(form);}
		if( form.com3.checked) { Val_3(form);}
		if( form.com1.checked) { Val_1(form);}
		if( form.com12.checked) { Val_12(form);}
	} // end com13

	if( Reso == true) { // Fres
		if(form.com2.checked == false) {
			alert("There is no secondary coil selected for analysis");
			good = false; return;
			}
		if( form.com2.checked) { Val_2(form); Val_13(form);}
		if( form.com3.checked) { Val_3(form); Val_14(form);}
		if( form.com1.checked) { Val_1(form);}
		if( form.com12.checked) { Val_12(form);}
		if(good == false) {Reso = false;}
	} // end Reso
		
	if( form.com10.checked) { // Lp
		Val_8(form);
	} // end com10
	
	if( form.com9.checked) { // Ls
		Val_9(form);
	} // end com9
	
	if( form.com11.checked) { // Lm
		Val_8(form);
		Val_9(form);		
	} // end com11
}// end Validation

function Val_2(form) { // specific to Ces and Resonance Analysis for Secondary Inputs
if((form.s_radius1.value == 0)&&(form.s_radius2.value == 0)&&(form.s_height1.value == 0)&&(form.s_height2.value == 0)) // if no dimensions
	{ alert('Input values are missing:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values');
	good = false; return;}

if ( ((form.s_radius1.value - form.s_radius2.value) == 0)&&((form.s_height1.value - form.s_height2.value) > 0) ) // if helical, h2 must be => h1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'For helical coils, the Bottom Height value must be greater than the Top Height value');
	good = false; return;}
	
if ( (form.s_radius1.value == 0)&&(form.s_radius2.value == 0)) // Both radius values cannot be set to 0
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y  C O I L input values\n' + 'The coil cannot have both Inside and Outside Radius values set to zero');
	good = false; return;}

if ( ((form.s_height1.value - form.s_height2.value) == 0)&&((form.s_radius1.value - form.s_radius2.value) >= 0)) // if flat, r2 must be > r1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'For flat coils, the Outside Radius value must be greater than the Inside Radius value\n' + 'If Ces or Resonance analysis, , increase the Outside Radius slightly');
	good = false; return;}

if ( ((form.s_radius1.value - form.s_radius2.value) > 0)&&((form.s_height1.value - form.s_height2.value) == 0) ) // if r1 > r2 and h1 == h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'TEST = R1 > R2 AND H1 == H2');
	good = false; return;}
	
if ( (form.s_height1.value - form.s_height2.value) > 0) // if h1 > h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'The Top Height value must not be less than the Bottom Height value');
	good = false; return;}
}

function Val_3(form) { // specific to Ces and Resonance Analysis for Primary Inputs
if((form.p_radius1.value == 0)&&(form.p_radius2.value == 0)&&(form.p_height1.value == 0)&&(form.p_height2.value == 0))//no dimensions
	{ alert('Input values are missing:\n\n' + '-->> check your P R I M A R Y   C O I L input values');
	good = false; return;}

if ( ((form.p_radius1.value - form.p_radius2.value) == 0)&&((form.p_height1.value - form.p_height2.value) > 0) ) // if helical, h2 must be => h1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'For helical coils, the Bottom Height value must be greater than the Top Height value');
	good = false; return;}

if ( (form.p_radius1.value == 0)&&(form.p_radius2.value == 0)) // Both radius values cannot be set to 0
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y  C O I L input values\n' + 'The coil cannot have both Inside and Outside Radius values set to zero');
	good = false; return;}

if ( ((form.p_height1.value - form.p_height2.value) == 0)&&((form.p_radius1.value - form.p_radius2.value) >= 0)) // if flat, r2 must be > r1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'For flat coils, the Outside Radius value must be greater than the Inside Radius value\n' + 'If Ces or Resonance analysis, increase the Outside Radius slightly');
	good = false; return;}
	
if ( ((form.p_radius1.value - form.p_radius2.value) > 0)&&((form.p_height1.value - form.p_height2.value) == 0) ) // if r1 > r2 and h1 == h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values');
	good = false; return;}
	
if ( (form.p_height1.value - form.p_height2.value) > 0) // if h1 > h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'The Top Height value must not be less than the Bottom Height value');
	good = false; return;}
}

function Val_13(form) { // specific to Resonance Analysis for Secondary Inputs
if ( form.s_turn.value < 1) // if turns < 1
	{ alert('Turns less than 1 are not permitted. Fantc is not designed to accurately model partial loops:\n\n' + '-->>check your S E C O N D A R Y   T U R N S input value');
	good = false; return;}
	
if (form.s_wirad.value <= 0) // if wire size <= 0
	{ alert('Input values are missing:\n' + '\n-->> check your S E C O N D A R Y  W I R E  S I Z E input value');
	good = false; return;}
}

function Val_14(form) { // specific to Resonance Analysis for Primary Inputs
if ( form.p_turn.value < 1) // if turns < 1
	{ alert('Turns less than 1 are not permitted. Fantc is not designed to accurately model partial loops:\n\n' + '-->>check your P R I M A R Y   T U R N S input value');
	good = false; return;}
	
if (form.p_wirad.value <= 0) // if wire size <= 0
	{ alert('Input values are missing:\n' + '\n-->> check your P R I M A R Y  W I R E  S I Z E input value');
	good = false; return;}
}

function Val_8(form) { // specific to Inductance Analysis for Primary Inputs
if ( form.p_turn.value < 1) // if turns < 1
	{ alert('Turns less than 1 are not permitted. Fantc is not designed to accurately model partial loops:\n\n' + '-->>check your P R I M A R Y   T U R N S input value');
	good = false; return;}
	
if (form.p_wirad.value <= 0) // if wire size <= 0
	{ alert('Input values are missing:\n' + '\n-->> check your P R I M A R Y  W I R E  S I Z E input value');
	good = false; return;}
	
if((form.p_radius1.value == 0)&&(form.p_radius2.value == 0)&&(form.p_height1.value == 0)&&(form.p_height2.value == 0))//no dimensions
	{ alert('Input values are missing:\n\n' + '-->> check your P R I M A R Y   C O I L input values');
	good = false; return;}

if ( ((form.p_radius1.value - form.p_radius2.value) == 0)&&((form.p_height1.value - form.p_height2.value) > 0) ) // if helical, h2 must be => h1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'For helical coils, the Bottom Height value must be greater than the Top Height value');
	good = false; return;}

if ( (form.p_radius1.value == 0)&&(form.p_radius2.value == 0)) // Both radius values cannot be set to 0
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y  C O I L input values\n' + 'The coil cannot have both Inside and Outside Radius values set to zero');
	good = false; return;}

if ( ((form.p_height1.value - form.p_height2.value) == 0)&&((form.p_radius1.value - form.p_radius2.value) >= 0)&&(form.p_turn.value != 1) ) // if flat, r2 must be > r1 unless single turn loop
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'For flat coils, the Outside Radius value must be greater than the Inside Radius value\n' + 'The only exception is an Inductance Analysis of a 1 turn loop, then, the Inside and Outside Radius values may be equal');
	good = false; return;}
	
if ( ((form.p_radius1.value - form.p_radius2.value) > 0)&&((form.p_height1.value - form.p_height2.value) == 0) ) // if r1 > r2 and h1 == h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values');
	good = false; return;}
	
if ( (form.p_height1.value - form.p_height2.value) > 0) // if h1 > h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your P R I M A R Y   C O I L input values\n' + 'The Top Height value must not be less than the Bottom Height value');
	good = false; return;}
}

function Val_9(form) { // specific to Inductance Analysis for Secondary Inputs
if ( form.s_turn.value < 1) // if turns < 1
	{ alert('Turns less than 1 are not permitted. Fantc is not designed to accurately model partial loops:\n\n' + '-->>check your S E C O N D A R Y  T U R N S input value');
	good = false; return;}
	
if (form.s_wirad.value <= 0) // if wire size <= 0
	{ alert('Input values are missing:\n' + '\n-->> check your S E C O N D A R Y  W I R E  S I Z E input value');
	good = false; return;}

if((form.s_radius1.value == 0)&&(form.s_radius2.value == 0)&&(form.s_height1.value == 0)&&(form.s_height2.value == 0)) // if no dimensions
	{ alert('Input values are missing:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values');
	good = false; return;}

if ( ((form.s_radius1.value - form.s_radius2.value) == 0)&&((form.s_height1.value - form.s_height2.value) > 0) ) // if helical, h2 must be => h1
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'For helical coils, the Bottom Height value must be greater than the Top Height value');
	good = false; return;}
	
if ( (form.s_radius1.value == 0)&&(form.s_radius2.value == 0)) // Both radius values cannot be set to 0
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y  C O I L input values\n' + 'The coil cannot have both Inside and Outside Radius values set to zero');
	good = false; return;}

if ( ((form.s_height1.value - form.s_height2.value) == 0)&&((form.s_radius1.value - form.s_radius2.value) >= 0)&&(form.s_turn.value != 1) ) // if flat, r2 must be > r1 unless single turn loop
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'For flat coils, the Outside Radius value must be greater than the Inside Radius value\n' + 'The only exception is an Inductance Analysis of a 1 turn loop, then, the Inside and Outside Radius values may be equal');
	good = false; return;}

if ( ((form.s_radius1.value - form.s_radius2.value) > 0)&&((form.s_height1.value - form.s_height2.value) == 0) ) // if r1 > r2 and h1 == h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'TEST = R1 > R2 AND H1 == H2');
	good = false; return;}
	
if ( (form.s_height1.value - form.s_height2.value) > 0) // if h1 > h2
	{ alert('Input values are missing or physically impossible:\n\n' + '-->> check your S E C O N D A R Y   C O I L input values\n' + 'The Top Height value must not be less than the Bottom Height value');
	good = false; return;}
}

function Val_1(form) {
if(form.g_radius.value == 0)
{ alert('Input value is missing:\n\n' + '-->> check your G R O U N D   P L A N E   R A D I U S input');
good = false; return;}
}

function Val_12(form) {
if((form.w_radius.value == 0)||(form.r_radius.value == 0)||(form.w_height.value == 0)||(form.r_height.value == 0))
{ alert('Input values are missing:\n' + '\n-->> check your W A L L  &  C E I L I N G  inputs\n-->> If Walls & Ceiling is selected, values must be entered\n-->> 0 is not accepted here');
good = false; return;}
}


////////////////////////////////////////////////////////////////////////
// Install Primary & Secondary - Allows drawing update
function drawcoil() {
	var form = document.JFANTC;
	var x = 0; var y = 0; var z = 0;
	NotNum(form);
	
	g_radius = document.JFANTC.g_radius.value;
	z = g_radius * g_radius;
if(z != 0) { var gnd = G.install_groundplane( UnitsIn(g_radius));}
	
	radius1 = document.JFANTC.s_radius1.value;
	height1 = document.JFANTC.s_height1.value;
	radius2 = document.JFANTC.s_radius2.value;
	height2 = document.JFANTC.s_height2.value;
	x = (radius1+radius2+height1+height2);
	
if(x != 0) {
	 var secondary = G.install_secondary( UnitsIn( radius1),
	  										UnitsIn( height1),
											UnitsIn( radius2),
											UnitsIn( height2), G.PROFILE_LOADED);
											}
	radius1 = document.JFANTC.p_radius1.value;
	height1 = document.JFANTC.p_height1.value;
	radius2 = document.JFANTC.p_radius2.value;
	height2 = document.JFANTC.p_height2.value;
	y = (radius1+radius2+height1+height2);

if(y != 0) {
	var primary = G.install_primary( UnitsIn( radius1),
                    		        	UnitsIn( height1),
										UnitsIn( radius2), 
										UnitsIn( height2),G.PROFILE_LOADED);
										}				
G.draw(); // call draw function
// prevent duplication on multiple clicks
if(x != 0)	{ G.remove(secondary);}	
if(y != 0)	{ G.remove(primary);}
if(z != 0)  { G.remove(gnd);}

radius1 = 0;
radius2 = 0;
height1 = 0;
height2 = 0;
}

function alertdet(form) {
	var form = document.JFANTC;
	if(det < 1) {alert("The minimum detail setting is 1"); form.det.value=1; eval(form.det); return;}
	if(det > 3) {alert("The maximum detail setting is 3"); form.det.value=3; eval(form.det); return;}
}

function RunC(form) {
	if((form.com13.checked == false)&&(form.com14.checked == false)&&(form.com15.checked == false)) {
	alert("You must first select an analysis to run"); return;}
	else {  analysis = 1;
			FTC(form);
			}
}
function RunL(form) {
	if((form.com9.checked == false)&&(form.com10.checked == false)&&(form.com11.checked == false)) {
	alert("You must first select an analysis to run"); return;}
	else {  analysis = 2;
			FTC(form);
			}
}
function RunR(form) {
	Reso = true;
	analysis = 3;
	FTC(form);
}
